import numpy as np
np.random.seed(1234)
import scipy.signal
from keras.models import Sequential
from keras.layers import Conv1D, Lambda
import keras.backend as K

def expand_last_dim(x):
    return K.expand_dims(x, axis=-1)
def expand_last_dim_output_shape(input_shape):
    shape = list(input_shape)
    shape = shape + [1]
    return tuple(shape)
ExpandLastDim = Lambda(expand_last_dim, output_shape=expand_last_dim_output_shape)

if __name__=="__main__":
    batch_size = 1
    samples = 1664
    window_len = 512
    window=np.sqrt(scipy.signal.hann(window_len, sym=False).astype(np.float32))
    hop_len = window_len / 4
    num_frames = 1 + (samples - window_len) / hop_len

    # sample a signal
    x = np.random.randn(batch_size, samples, 1)

    model = Sequential()
    model.add(Conv1D(window_len, window_len, strides=hop_len, use_bias=False, input_shape=(samples, 1)))
    K.set_value(model.layers[-1].weights[0], np.reshape(np.diag(window), (window_len, 1, window_len)))

    frames = model.predict(x)

