import numpy as np
np.random.seed(1234)
import scipy.signal
import librosa
import custom_librosa

if __name__=="__main__":
    y, sr = librosa.load(librosa.util.example_audio_file())
    n = len(y)
    n_win = 512
    n_fft = 2048
    y_pad = np.pad(y, (n_win, n_win), 'constant', constant_values=(0., 0.))
    window=np.sqrt(scipy.signal.hann(n_win, sym=False).astype(np.float32))
    D = librosa.stft(y_pad, n_fft=n_fft, win_length=n_win, window=window, hop_length=n_win/4)
    yr = librosa.istft(D, length=n+2*n_win, win_length=n_win, window=window, hop_length=n_win/4)[n_win:-n_win]
    yr2 = custom_librosa.istft_nodiv(D, length=n+2*n_win, win_length=n_win, window=window/2, hop_length=n_win/4)[n_win:-n_win]

    print "MSE of reconstruction: %f" % (np.mean((y - yr)**2))
    print "MSE of reconstruction (no division by window sum): %f" % (np.mean((y - yr2)**2))
